# boek/plugs/manage.py
#
#

""" regen, regen. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from boek.runtime import kernel, mods
from boek import defaults

import logging

## manage.stop command

def manage_stop(event):
    if not event.args: return
    kernel.stop(event.rest())
    event.ok()

kernel.register("manage.stop", manage_stop)

## manage.start command

def manage_start(event):
    if not event.args: return
    cfg = get_cfg(event.args[0])
    if cfg: cfg.save() 
    kernel.init(event.args[0])
    event.ok()

kernel.register("manage.start", manage_start)

## manage.reload command

def manage_reload(event): 
    if not event.args: return
    result = kernel.mods.reload_name(event.rest())
    if result: event.ok(get_named(result))

kernel.register("manage.reload", manage_reload)

## HELPERS

def get_cfg(*args, **kwargs):
    try: return getattr(defaults, "cfg_%s" % args[0])
    except AttributeError: pass
