# boek/runtime.py
#
#

""" basic package for the program. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from boek.defaults import cfg_kernel
from boek.utils import make_opts, hello, error
from boek.dispatcher import DISPATCHER
from boek.defines import opts_defs
from boek.plugins import PLUGINS
from boek.object import Object
from boek.log import init

import logging
import sys
import os

def boekpath():
    for path in sys.path:
        if "boek" in path and "egg" in path: yield path  

## KERNEL

class KERNEL(PLUGINS):

    def __init__(zelf, *args, **kwargs):
        zelf.mods = PLUGINS()
        zelf.cfg = Object()

    def boot(zelf, *args, **kwargs):
        opts, arglist = make_opts(opts_defs)
        cfg.update(cfg_kernel)
        cfg.update(vars(opts))
        cfg.runargs = arglist
        cfg.shell = True
        if arglist: cfg.shell = False
        if cfg.shell and args: hello(args[0])
        init(zelf.cfg.loglevel)
        if zelf.cfg.loglevel != "error":
            print("\n".join(sorted(zelf.cfg.show())))
            print("path=%s" % ", ".join(list(boekpath()))) 
            print("")
        for package in zelf.cfg.packages:
            try: zelf.mods.load(package)
            except: error()
        zelf.mods.init(cfg.init)
        zelf.ready()
        return zelf

    def shutdown(zelf, *args, **kwargs): logging.warn("shutdown")

## DEFINES

kernel = KERNEL()
mods = kernel.mods
cfg = kernel.cfg
fleet = []
